#ifndef GPSREADER_H
#define GPSREADER_H
// GPSReader
// Thread object that reads GPS data from the serial port and sends it to 
// a BMessenger (the GPSServer app)
#include <app/Messenger.h>
#include <device/SerialPort.h>
#include <stdio.h>

class GPSReader
{
public:
	GPSReader(int32 serial_port, BMessenger& dispatcher);
	~GPSReader();
	thread_id Go();	// Start the reader
	
	// Exceptions
	struct Error {
		const char *msg;
		Error(const char* error) { msg = error; }
	};
private:
	static int32 thread_func(void *arg);
	int32 threadFunc();
	
	thread_id my_thread;
	char portname[B_OS_NAME_LENGTH];
	BSerialPort serial;
	BMessenger dest;
};

#endif // GPSREADER_H