// a test gps client

#define DEBUG true

#include "GPSMessages.h"
#include <app/Application.h>
#include <app/Message.h>
#include <app/Messenger.h>
#include <interface/Button.h>
#include <interface/StringView.h>
#include <support/Debug.h>

const char GPS_SERVER_SIG[40] = "application/x-vnd.BUGatUIUC-gps_server";

class foo : public BApplication {
public:
	foo() : BApplication("application/x-vnd.JasonLuther-GPSTestApp")  {
		SetPulseRate(50000);
		window = new BWindow(BRect(100,100,250,250), "GPS Test", B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE);
		BView* base = new BView(window->Bounds(), "base", B_FOLLOW_ALL_SIDES, B_WILL_DRAW | B_NAVIGABLE);
		window->AddChild(base);
		base->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
		BRect button_rect(5,5,145,30);
		base->AddChild(new BButton(button_rect, "sub button", "Subscribe", new BMessage('taGO')));
		cast_as(base->FindView("sub button"), BInvoker)->SetTarget(be_app_messenger);
		button_rect.OffsetBy(0,35);
		button_rect.OffsetBy(0,35);
		base->AddChild(new BStringView(button_rect, "string view", "glop"));
		window->Show();
	}
	
	virtual void Pulse() {
		if (CountWindows() == 0)
			PostMessage(B_QUIT_REQUESTED);
	}
	
	virtual void MessageReceived(BMessage* msg) {
		msg->PrintToStream();
		switch (msg->what) {
			case 'taGO': {
				BMessage sub(GPS_SUBSCRIBE);
				sub.AddMessenger("client", be_app_messenger);
				be_roster->Launch(GPS_SERVER_SIG);
				BMessenger server(GPS_SERVER_SIG);
				server.SendMessage(&sub);
				break;
			}
			case 'taNG': {
				BMessenger server(GPS_SERVER_SIG);
				BMessage unsub(GPS_UNSUBSCRIBE);
				unsub.AddMessenger("client", be_app_messenger);
				server.SendMessage(&unsub);
				break;
			}
			case GPS_RAW_DATA: {
				window->Lock();
				cast_as(window->FindView("string view"), BStringView)->SetText(msg->FindString("type"));
				window->Unlock();
				break;
			}
			default: {
				BApplication::MessageReceived(msg);
				break;
			}
		}
	}
protected:
	BWindow* window;
};

int main() {
	foo bar;
	bar.Run();
	return 0;
}
